package com.accuver.cem.view.frag;

import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;

import org.json.JSONException;
import org.json.JSONObject;


import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnDismissListener;
import android.graphics.Typeface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.util.Log;
import android.util.TypedValue;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.accuver.cem.view.graph.SpeedChartView;
import com.accuver.cem.view.util.CustomViewPager;
import com.accuver.cem.view.util.TypeFaces;
import com.accuver.jpcem.CEMApplication;

import com.accuver.jpcem.R;

import com.samknows.libcore.SKLogger;
import com.samknows.measurement.CachingStorage;
import com.samknows.measurement.CollectDeviceInfo;
import com.samknows.measurement.ManualTest;
import com.samknows.measurement.SK2AppSettings;
import com.samknows.measurement.SKApplication;
import com.samknows.measurement.Storage;
import com.samknows.measurement.environment.TrafficStatsCollector;
import com.samknows.measurement.schedule.ScheduleConfig;
import com.samknows.measurement.schedule.TestDescription;
import com.samknows.measurement.storage.TestResult;
import com.samknows.measurement.util.WaitQueue;
import com.samknows.tests.Param;

public class Frag_Measurement extends Fragment implements OnClickListener {

	private static final String TAG = Frag_Measurement.class.getSimpleName();
	
	private FragmentActivity mActivity = null;
	private SpeedChartView mSpeedChartView;
	private TextView tv_gps_info, tv_net_supplier;
	private TextView tv_main_unit_avg, tv_main_speed_avg, tv_latency, tv_throughput_dn, tv_throughput_up, tv_download_max, tv_upload_max, tv_packet_loss;
	private Button btn_measure_start, btn_lte_rf_more_and_cell_id;
	private ProgressBar pb_progress_ping, pb_progress_down, pb_progress_up, pb_progress_loss;
	//inprogress --adding 
	private LinearLayout lly_main_speed_avg;
	private TextView tv_server_name;
	
	
	private int criterion;
	
	protected boolean mMobileError = false;
	protected int mPreSec;

	public static boolean isDialogOpen = false;
	
	
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

		
		mActivity = getActivity();
		
		View rootView = inflater.inflate(R.layout.frag_measurement, container, false);
		findView(rootView);		
		updateView();
		
		Log.d(TAG, "onCreateView()");
		return rootView;
	}

	@Override
	public void onDestroyView() {
		super.onDestroyView();
		Log.d(TAG, "onDestroyView()");
	}

	@Override
	public void onResume() {
		Log.d(TAG, "onResume()");
		super.onResume();
		if (refreshViewHandler != null)
		{
			refreshViewHandler.post(refreshViewRunnable);
		}
		
		if(mSpeedChartView != null){
			mSpeedChartView.resume();
			mSpeedChartView.setNeedDisplay();
		}
		updateString();
		
		if(!isTesting){
			btn_measure_start.setText(R.string.measure_start);
		}
		else {
			btn_measure_start.setText(R.string.measure_stop);
		}
		
		runBGTest();
	}
	
	public void runBGTest() {
		CEMApplication app = (CEMApplication)mActivity.getApplication();
		ManualTest test = app.getManualTest();
		if(test != null && ManualTest.isExecuting){
			// Connect handler
			mt = test;
			mt.setHandler(mActivityHandler);
			isTesting = true;
			// UI
			btn_measure_start.setText(R.string.measure_stop);
			mActivity.getActionBar().hide();
			CustomViewPager viewPager = (CustomViewPager) mActivity.findViewById(R.id.pager);
			viewPager.setPagingEnabled(false);
		}		
	}

	@Override
	public void onPause() {

		// Speed Chart
		if(mSpeedChartView != null){
			mSpeedChartView.pause();
		}
		if (null != refreshViewHandler)
			refreshViewHandler.removeCallbacks(refreshViewRunnable);

		super.onPause();
	}
	
	public void onStart() {
		super.onStart();
		Log.d(TAG, "onStart()");
	}
	
	public void onStop() {
		super.onStop();
		Log.d(TAG, "onStop()");
	}
    
	@Override
	public void onClick(View v) {
		int id = v.getId();
		switch (id) {
		case R.id.btn_measure_start:
			if(!isTesting){
				launchTest();
				//activeClosestTest();
			}
			else {
				stopTest();
			}
			
			break;
		case R.id.btn_lte_rf_more_and_cell_id:

			break;
		}
	}
	
	
//	private void activeClosestTest(){
//		Intent intent = new Intent(mActivity, SKAActivationActivity.class);
//		mActivity.startActivityForResult(intent, Frag_TabMain.RESULT_ID_CLOSEST);
//	}
	
	
	private boolean isTesting = false;
	private void stopTest(){
		isTesting = false;
		if(mRepeatTimer != null){
			mRepeatTimer.cancel();
			mRepeatTimer = null;
		}
		
		mActivity.getActionBar().show();
		CustomViewPager viewPager = (CustomViewPager) mActivity.findViewById(R.id.pager);
		viewPager.setPagingEnabled(true);

		btn_measure_start.setText(R.string.measure_start);
		if(mt != null) {
			mt.stop(); 
			mt = null;
		}
		if(mCollector != null){
			long bytes = mCollector.finish();
			SK2AppSettings.getSK2AppSettingsInstance().appendUsedBytes(bytes);
			mCollector = null;
		}
		//clearTest();
		mSpeedChartView.setAverageThroughput(0);
		mSpeedChartView.setInstantThroughput(0);
	}
	
	private void clearTest(){
		if(pb_progress_down != null) pb_progress_down.setProgress(0);
		if(pb_progress_up != null) pb_progress_up.setProgress(0);
		if(pb_progress_ping != null) pb_progress_ping.setProgress(0);
		if(pb_progress_loss != null) pb_progress_loss.setProgress(0);
		clearString();
		updateString();
	}
	
	private ManualTest mt = null;
	private boolean isRepeat;
	private int nRepeatCount;
	private int nRunCount;
	private int nIdleTime;
	public void launchTest() {
		isTesting = true;
		//UI
		btn_measure_start.setText(R.string.measure_stop);
		mActivity.getActionBar().hide();
		CustomViewPager viewPager = (CustomViewPager) mActivity.findViewById(R.id.pager);
		viewPager.setPagingEnabled(false);

		// repeat count, repeat enable, idle time
		// check download size
		// check upload size
		Storage storage = CachingStorage.getInstance();
        ScheduleConfig config = storage.loadScheduleConfig();
        int download_session = 0;
        int download_filesize = 0;
        int upload_session = 0;
        int upload_filesize = 0;
        
		for(TestDescription td : config.tests){
			if(td.displayName == null) continue;
			
        	if(td.displayName.equalsIgnoreCase("Common")){
        		for(Param param : td.params){
        			String name = param.getName();
        			String value = param.getValue();
        			if(name.equalsIgnoreCase("Count")){
        				nRepeatCount = Integer.parseInt(value);
        			}
        			else if(name.equalsIgnoreCase("Autorepeat")){
        				isRepeat = (Integer.parseInt(value) == 1) ? true : false;
        			}
        			else if(name.equalsIgnoreCase("Idel")){
        				nIdleTime = Integer.parseInt(value);
        			}
        		}
        		//break;
        	}
        	else if(td.displayName.equalsIgnoreCase("Upload")) {
        		for(Param param : td.params){
        			String name = param.getName();
        			String value = param.getValue();
        			if(name.equalsIgnoreCase("session")){
        				upload_session = Integer.parseInt(value);
        			}
        			else if(name.equalsIgnoreCase("filesize")){
        				upload_filesize = Integer.parseInt(value);
        			}
        		}
        	}
        	else if(td.displayName.equalsIgnoreCase("Download")) {
        		for(Param param : td.params){
        			String name = param.getName();
        			String value = param.getValue();
        			if(name.equalsIgnoreCase("session")){
        				download_session = Integer.parseInt(value);
        			}
        			else if(name.equalsIgnoreCase("filesize")){
        				download_filesize = Integer.parseInt(value);
        			}
        		}
        	}
        }
		nRunCount = 0;
		
		///////////////////////////////////////////////////////
		//need that data size will be consumed.
		//  (download complete size + warm up size ) * session count
		//  (upload complete size + warm up size ) * session count
		// download total size + upload total size = need size
		Log.d(TAG,"upload_session:"+upload_session+" upload_filesize:"+upload_filesize);
		Log.d(TAG,"download_session:"+download_session+" download_filesize:"+download_filesize);
		
		if (SKApplication.getAppInstance().getIsDataCapEnabled() == true) {
			long need_size = (long) (((upload_filesize*1024L*1024L) + (2.5*1024L*1024L))*upload_session);
			need_size += ((download_filesize*1024L*1024L) + (2.5*1024L*1024L))*download_session;
			Log.d(TAG,"need_size:"+need_size);

			String showWithMessage = "";
		    if (SK2AppSettings.getSK2AppSettingsInstance().isDataCapReached(need_size)) {
    			showWithMessage = getString(R.string.data_cap_exceeded);
	    	}
			if (showWithMessage.length() > 0) {
				new AlertDialog.Builder(mActivity)
				.setMessage(showWithMessage)
				.setPositiveButton(R.string.setting_alert_yes, new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						tryTest();
					}
				})
				.setNegativeButton(R.string.setting_alert_no, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						stopTest();
					}
				}).show();
				return;
			}
		}
		/////////////////////////////////////////////////////

		tryTest();
	}
	private TrafficStatsCollector mCollector = null;
	private void tryTest(){
		//UI
		clearTest();
		
		StringBuilder errorDescription = new StringBuilder();
		// create a new thread
		mt = ManualTest.create(mActivity, mActivityHandler, errorDescription);

		if (mt == null) {
			String theErrorString = errorDescription.toString();
			if (theErrorString.length() == 0) {
				theErrorString = getString(R.string.manual_test_error);
			}
			
			new AlertDialog.Builder(mActivity)
					.setMessage(theErrorString)
					.setPositiveButton(R.string.ok_dialog,
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int id) {

								}
							}).show();
			
			return;
		}
		mt.setIsRepeatTest(isRepeat);
		
		//data collector
		mCollector = new TrafficStatsCollector(mActivity);
		mCollector.start();
		
		String target = mt.getTargetAddress();
		int port = mt.getSpeedTestPost();
		WaitQueue queue = new WaitQueue(target,port);
		queue.check(mActivityHandler);
		mWaitQueue = queue;
	}
	
	
	private WaitQueue mWaitQueue = null;
	private AlertDialog mWaitDialog = null;

	private void startTest(ManualTest mt) {
		if (mSpeedChartView != null) {
			mSpeedChartView.setMaxThroughput(80 * 1000, 5, "(Mbps)");
			mSpeedChartView.setAverageThroughput(0);
			mSpeedChartView.setInstantThroughput(0);
		}
		new Thread(mt).start();
	}

	

	private Timer mRepeatTimer = null;
	
	
	
	/*
	 * ⼭   ִ Event  Ѵ. 
	 * 
	 */
	
	private Handler mActivityHandler = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			
			if(msg.what == WaitQueue.MSG_WAITQUEUE_EMPTY){
				if(mWaitDialog != null){
					mWaitDialog.dismiss();
				}
				if(mt != null){
					startTest(mt);
				}
				return;
			}
			else if(msg.what == WaitQueue.MSG_WAITQUEUE_WAIT){
				int count = msg.arg1;
				
				if(mWaitDialog == null && mWaitQueue != null){
					LayoutInflater factory = LayoutInflater.from(mActivity);
		            final View standByView = factory.inflate(R.layout.alert_standby, null);

		            //make AlertDialog
					AlertDialog.Builder ab = new AlertDialog.Builder(mActivity);
					ab.setTitle("Information");
					ab.setMessage(R.string.measure_waitq_msg);
					ab.setView(standByView);
					ab.setNegativeButton(R.string.measure_waitq_cancel, new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int whichButton) {
							if(mWaitQueue != null){
								mWaitQueue.cancel();
								mWaitQueue = null;
							}
							stopTest();
						}
					});
					mWaitDialog = ab.show();
					mWaitDialog.setOnDismissListener(new OnDismissListener(){
						@Override
						public void onDismiss(DialogInterface dialog) {
							mWaitDialog = null;
						}
					});
				}
				
				if(mWaitDialog != null){
					TextView countView = (TextView)mWaitDialog.findViewById(R.id.count_text);
					if(countView != null){
						countView.setText(""+count);
					}	
				}
				
				return;
			}
			
			if(mt == null) return;
			
			
			JSONObject message_json;
			message_json = (JSONObject) msg.obj;
			int testname;
			int progress;
			int avg_speed;
			int current_speed;
			int peak_speed;
			float packet_loss;
			
			if(message_json == null){
				Log.e(TAG,"Unknown message:"+msg.what);
				return;
			}
			
			try {

				String type = message_json.getString(TestResult.JSON_TYPE_ID);

				// test completed
				if (type == "completed") {
					Log.e(TAG,"completed Test");
					if (mSpeedChartView != null) {
						mSpeedChartView.setAverageThroughput(0);
						mSpeedChartView.setInstantThroughput(0);
						mActivityHandler.postDelayed(new Runnable(){
							@Override
							public void run() {
								mSpeedChartView.setActivation(false);
							}
						}, 1500);
					}
					backupString();
					mt = null;
					
					
					// Show Toast
					String str_complete = getResourceString(R.string.measure_test_complete);
					Toast.makeText(mActivity, str_complete, Toast.LENGTH_SHORT).show();
					
					// Repeat Test
					if(isRepeat){
						nRunCount++;
						if(nRepeatCount == nRunCount){
							stopTest();
						}
						else {
							Log.e(TAG,"RunCount:"+nRunCount+" RepeatCount:"+nRepeatCount+" IdleTime:"+nIdleTime);
							mRepeatTimer = new Timer();
							TimerTask timerTask = new TimerTask() {
								@Override
								public void run() {
									mActivityHandler.post(new Runnable(){
										@Override
										public void run() {
											tryTest();					
										}
									});
								}        
							}; 
							mRepeatTimer.schedule(timerTask, nIdleTime*1000*60);
						}
					}
					else {
						stopTest();
					}
//					//need history update
//					Frag_TabMain activity = (Frag_TabMain)mActivity;
//					activity.updateHistory();
				}

				// test testing
				else if (type == "test") {
					testname = message_json.getInt(TestResult.JSON_TESTNUMBER);
					progress = message_json.getInt(TestResult.JSON_STATUS_COMPLETE); //progress
					
					avg_speed = message_json.getInt(TestResult.JSON_SPEED);
					current_speed = message_json.getInt(TestResult.JSON_INTERVAL);
					peak_speed = message_json.getInt(TestResult.JSON_PEAK);
					packet_loss = (float) message_json.getDouble(TestResult.JSON_LOSS);
					packet_loss *= 100d;
					
					mSpeedChartView.setActivation(true);


					switch (testname) {
					// active metrics
					case TestResult.DOWNLOAD_TEST_ID:
						//Log.d(TAG,"download avg_speed:"+avg_speed);
						mSpeedChartView.setMaxThroughput(100 * 1000, 5, "(Mbps)");
						if(pb_progress_down != null) pb_progress_down.setProgress(progress);
						{
							float fSpeed = (float)current_speed;
							fSpeed = (float)(fSpeed * 8d / 1000000);
							//main
							tv_main_speed_avg.setText(String.format(Locale.getDefault(), "%.1f", fSpeed));
							tv_main_unit_avg.setText("Mbps");
							if( fSpeed > 0) mSpeedChartView.setInstantThroughput(fSpeed*1000);
							//throughput
							fSpeed = (float)avg_speed;
							fSpeed = (float)(fSpeed * 8d / 1000000);
							tv_throughput_dn.setText(String.format(Locale.getDefault(), "%.1f", fSpeed));
							if( fSpeed > 0) mSpeedChartView.setAverageThroughput(fSpeed*1000);
							//peak
							fSpeed = (float)peak_speed;
							fSpeed = (float)(fSpeed * 8d / 1000000);
							tv_download_max.setText(String.format(Locale.getDefault(), "P:%.1f", fSpeed));
						}
						break;
					case TestResult.UPLOAD_TEST_ID:
						//Log.d(TAG,"upload avg_speed:"+avg_speed);
						mSpeedChartView.setMaxThroughput(100 * 1000, 5, "(Mbps)");
						if(pb_progress_up != null) pb_progress_up.setProgress(progress);
						{
							float fSpeed = (float)current_speed;
							fSpeed = (float)(fSpeed * 8d / 1000000);
							//main
							tv_main_speed_avg.setText(String.format(Locale.getDefault(), "%.1f", fSpeed));
							tv_main_unit_avg.setText("Mbps");
							if( fSpeed > 0) mSpeedChartView.setInstantThroughput(fSpeed*1000);
							//throughput
							fSpeed = (float)avg_speed;
							fSpeed = (float)(fSpeed * 8d / 1000000);
							tv_throughput_up.setText(String.format(Locale.getDefault(), "%.1f", fSpeed));
							if( fSpeed > 0) mSpeedChartView.setAverageThroughput(fSpeed*1000);
							//peak
							fSpeed = (float)peak_speed;
							fSpeed = (float)(fSpeed * 8d / 1000000);
							tv_upload_max.setText(String.format(Locale.getDefault(), "P:%.1f",  fSpeed));	
						}
						break;
					case TestResult.PACKETLOSS_TEST_ID:
						if(pb_progress_loss != null) pb_progress_loss.setProgress(progress);
						{
							tv_packet_loss.setText(String.format(Locale.getDefault(), "%.2f",  packet_loss));
						}
						
						break;
					case TestResult.LATENCY_TEST_ID:
						if(pb_progress_ping != null) pb_progress_ping.setProgress(progress);
						mSpeedChartView.setMaxThroughput(100 * 1000, 5, "(ms)");
						{
							float fLatency = (float)current_speed;
							//main
							tv_main_speed_avg.setText(String.format(Locale.getDefault(), "%.0f", (float)fLatency));
							tv_main_unit_avg.setText("ms");
							if( fLatency > 0) mSpeedChartView.setInstantThroughput(fLatency * 1000);
							//avarage
							fLatency = (float)avg_speed;
							tv_latency.setText(String.format("%.0f", (float)fLatency));
							if( fLatency > 0) mSpeedChartView.setAverageThroughput(fLatency*1000);
						}
						break;
					case TestResult.JITTER_TEST_ID:
						
						break;

					}
				}
				else {
					Log.e(TAG,"JSON_TYPE_ID:"+type);
					if(type.equals("3")){
						//Log.e(TAG,"loss complete! "+message_json.toString());
					}
					else if(type.equals("2")) // finish latency test
					{ 
						if (mSpeedChartView != null) {
							mSpeedChartView.setAverageThroughput(0);
							mSpeedChartView.setInstantThroughput(0);
						}
					}
					else if(type.equals("1")) // finish upload test
					{
						if (mSpeedChartView != null) {
							mSpeedChartView.setAverageThroughput(0);
							mSpeedChartView.setInstantThroughput(0);
						}
						avg_speed = message_json.getInt("result");
						peak_speed = message_json.getInt("peak");
						float fSpeed = (float)avg_speed;
						fSpeed = (float)(fSpeed / 1000000);
						tv_throughput_up.setText(String.format(Locale.getDefault(), "%.1f", fSpeed));
						fSpeed = (float)peak_speed;
						fSpeed = (float)(fSpeed / 1000000);
						tv_upload_max.setText(String.format(Locale.getDefault(), "P:%.1f", fSpeed));
						
					}
					else if(type.equals("0")) // finish download test
					{
						if (mSpeedChartView != null) {
							mSpeedChartView.setAverageThroughput(0);
							mSpeedChartView.setInstantThroughput(0);
						}
						avg_speed = message_json.getInt("result");
						peak_speed = message_json.getInt("peak");
						
						float fSpeed = (float)avg_speed;
						fSpeed = (float)(fSpeed / 1000000);
						tv_throughput_dn.setText(String.format(Locale.getDefault(), "%.1f", fSpeed));
						fSpeed = (float)peak_speed;
						fSpeed = (float)(fSpeed / 1000000);
						tv_download_max.setText(String.format(Locale.getDefault(), "P:%.1f", fSpeed));
					}
				}

			} catch (JSONException e) {
				SKLogger.e(this, e.getMessage());
			}

		}
	};
	
	private String text_main_speed_avg;
	private String text_main_unit_avg;
	private String text_throughput_dn;
	private String text_throughput_up;
	private String text_download_max;
	private String text_upload_max;
	private String text_latency;
	private String text_packet_loss;
	private void backupString() {
		text_main_speed_avg = tv_main_speed_avg.getText().toString();
		text_main_unit_avg = tv_main_unit_avg.getText().toString();
		text_throughput_dn = tv_throughput_dn.getText().toString();
		text_throughput_up = tv_throughput_up.getText().toString();
		text_download_max = tv_download_max.getText().toString();
		text_upload_max = tv_upload_max.getText().toString();
		text_latency = tv_latency.getText().toString();
		text_packet_loss = tv_packet_loss.getText().toString();
	}
	private void clearString() {
		text_main_speed_avg = "0.0";	
		text_main_unit_avg = "Mbps";	
		text_throughput_dn = "-";		
		text_throughput_up = "-";		
		text_download_max = "";			
		text_upload_max = "";			
		text_latency = "-";
		text_packet_loss = "-";
	}
	private void updateString() {
		if(text_main_speed_avg == null) return;
		
		tv_main_speed_avg.setText(text_main_speed_avg);
		tv_main_unit_avg.setText(text_main_unit_avg);
		tv_throughput_dn.setText(text_throughput_dn);
		tv_throughput_up.setText(text_throughput_up);
		tv_download_max.setText(text_download_max);
		tv_upload_max.setText(text_upload_max);
		tv_latency.setText(text_latency);
		tv_packet_loss.setText(text_packet_loss);
	}
	
	private void findView(View view) {
		
		mSpeedChartView = (SpeedChartView) view.findViewById(R.id.speedchart);

		// pb_progress = (ProgressBar) findViewById(R.id.pb_progress);
		// pb_progress.setMax(100);

		btn_lte_rf_more_and_cell_id = (Button) view.findViewById(R.id.btn_lte_rf_more_and_cell_id);
		btn_lte_rf_more_and_cell_id.setOnClickListener(this);
		
		
		tv_gps_info = (TextView) view.findViewById(R.id.tv_gps_info);
		setTextFace(tv_gps_info);
		tv_net_supplier = (TextView) view.findViewById(R.id.tv_net_supplier);
		setTextFace(tv_net_supplier);

		// Speed section
		lly_main_speed_avg = (LinearLayout) view.findViewById(R.id.lly_main_speed_avg);
		
		tv_main_speed_avg = (TextView) view.findViewById(R.id.tv_main_speed_avg);
		tv_main_unit_avg = (TextView) view.findViewById(R.id.tv_main_unit_avg);
		tv_throughput_dn = (TextView) view.findViewById(R.id.tv_throughput_dn);
		tv_throughput_up = (TextView) view.findViewById(R.id.tv_throughput_up);
		tv_download_max = (TextView) view.findViewById(R.id.tv_download_max);
		tv_upload_max = (TextView) view.findViewById(R.id.tv_upload_max);
		tv_latency = (TextView) view.findViewById(R.id.tv_latency);
		tv_packet_loss = (TextView) view.findViewById(R.id.tv_packet_loss);

		setTextFace(tv_main_speed_avg);
		setTextFace(tv_main_unit_avg);
		setTextFace(tv_throughput_dn);
		setTextFace(tv_throughput_up);
		setTextFace(tv_download_max);
		setTextFace(tv_upload_max);
		setTextFace(tv_latency);
		setTextFace(tv_packet_loss);

		pb_progress_down = (ProgressBar) view.findViewById(R.id.pb_progress_down);
		pb_progress_down.setMax(100);
		pb_progress_up = (ProgressBar) view.findViewById(R.id.pb_progress_up);
		pb_progress_up.setMax(100);
		pb_progress_ping = (ProgressBar) view.findViewById(R.id.pb_progress_ping);
		pb_progress_ping.setMax(100);
		pb_progress_loss = (ProgressBar) view.findViewById(R.id.pb_progress_loss);
		pb_progress_loss.setMax(100);
		
		//---------------
		
		btn_measure_start = (Button) view.findViewById(R.id.btn_measure_start);
		btn_measure_start.setOnClickListener(this);

		if (isTesting) {
			btn_measure_start.setText(R.string.measure_stop);
		} else {
			btn_measure_start.setText(R.string.measure_start);
		}
		
		tv_server_name = (TextView) view.findViewById(R.id.tv_server_name);
		
	}

	private void setTextFace(TextView tv) {
		tv.setTypeface(TypeFaces.get(mActivity, "NeoSans-Medium.otf"), Typeface.BOLD);
	}

	private Handler refreshViewHandler = new Handler();
	private Runnable refreshViewRunnable = new Runnable() {
		@Override
		public void run() {
			updateView();
			refreshViewHandler.postDelayed(refreshViewRunnable, 1000);
		}
	};

	private String getResourceString(int id){
		if(id == 0) return "";
		try{
			return mActivity.getResources().getString(id);
		}
		catch(Exception e){
			
		}
		return "";
	}
	
	@SuppressLint("NewApi")
	private void updateView() {
		
		CollectDeviceInfo device = CollectDeviceInfo.getInstance();
		String gps = getResourceString(R.string.measure_gps);
		
		if (device.latitude == 0 || device.longitude == 0) {
			tv_gps_info.setText(gps+" N/A");
		} else {
			tv_gps_info.setText(String.format(Locale.getDefault(), "%s %.3f / %.3f",gps, device.latitude, device.longitude));
		}

		if(device.net != null && device.operatorName != null){
			tv_net_supplier.setText(String.format(Locale.getDefault(), "%s / %s", device.operatorName, device.net));
		}
		
		if(device.bestTarget != null){
			tv_server_name.setText(device.bestTarget);
		}
		
		{
			String cell_id = getResourceString(R.string.measure_cell_id);
			String rssi = getResourceString(R.string.measure_rssi);
			String str_cell_id = null; 
			if(device.net != null && device.net.equals("WIFI")){
				str_cell_id = cell_id+" : - / "+rssi+" : - (dBm)";
			}
			else {
				str_cell_id = cell_id+" : "+device.getCellID()+" / "+rssi+" : "+device.getRSSI()+"(dBm)";
			}
			btn_lte_rf_more_and_cell_id.setText(str_cell_id);
		}
		
		
		// Setting size for variable DP
		criterion = lly_main_speed_avg.getHeight();
		tv_main_speed_avg.setTextSize(TypedValue.COMPLEX_UNIT_SP, changSize(criterion, 55));
		btn_measure_start.setTextSize(TypedValue.COMPLEX_UNIT_SP, changSize(criterion, 30));
		tv_latency.setTextSize(TypedValue.COMPLEX_UNIT_SP, changSize(criterion, 35));
		tv_throughput_dn.setTextSize(TypedValue.COMPLEX_UNIT_SP, changSize(criterion, 35));
		tv_throughput_up.setTextSize(TypedValue.COMPLEX_UNIT_SP, changSize(criterion, 35));
		tv_download_max.setTextSize(TypedValue.COMPLEX_UNIT_SP, changSize(criterion, 14));
		tv_upload_max.setTextSize(TypedValue.COMPLEX_UNIT_SP, changSize(criterion, 14));
		
		btn_lte_rf_more_and_cell_id.setTextSize(TypedValue.COMPLEX_UNIT_SP, changSize(criterion, 17));
		

	}
	
	private int changSize(int criterion, int maximum) {
		int sp, tmp;
		if(criterion != 0){
			tmp = (int)(criterion/(float)100 * maximum);
			sp = tmp > maximum ? maximum : tmp; 
			return sp;
		}else{
			return 0;
		}
	}

	
}
