package com.accuver.cem.view.util;

import java.util.Locale;

import android.app.Dialog;
import android.content.Context;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.accuver.cem.struc.HistoryItem;
import com.accuver.jpcem.R;


public class HistoryDetailDialog extends Dialog implements android.view.View.OnClickListener{

	
	private Context mContext;
	public HistoryDetailDialog(Context context, HistoryItem item) {
		super(context);
		mContext = context;
		
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.dialog_detail);
		
		//Grab the window of the dialog, and change the width
		WindowManager.LayoutParams lp = new WindowManager.LayoutParams();
		Window window = getWindow();
		lp.copyFrom(window.getAttributes());
		//This makes the dialog take up the full width
		lp.width = WindowManager.LayoutParams.MATCH_PARENT;
		lp.height = WindowManager.LayoutParams.WRAP_CONTENT;
		window.setAttributes(lp);
		
		((Button)findViewById(R.id.btn_Close)).setOnClickListener(this);
		TextView tv_title = (TextView)findViewById(R.id.tv_title);
		TextView tv_start_date = (TextView)findViewById(R.id.tv_start_date);
		TextView tv_end_date = (TextView)findViewById(R.id.tv_end_date);
		TextView tv_data_titles = (TextView)findViewById(R.id.tv_data_titles);
		TextView tv_data_values = (TextView)findViewById(R.id.tv_data_values);
		
		((LinearLayout)findViewById(R.id.lly_alert)).setVisibility(View.GONE);
		((LinearLayout)findViewById(R.id.lly_data_sub)).setVisibility(View.GONE);
		((Button)findViewById(R.id.btn_Save)).setVisibility(View.GONE);
		((TextView)findViewById(R.id.tv_midleTitle)).setVisibility(View.GONE);
		((TextView)findViewById(R.id.tv_midle_line)).setVisibility(View.GONE);
		
		if(item == null){
			tv_title.setText(String.valueOf("n/a"));
			tv_start_date.setText(String.valueOf("n/a"));
			tv_end_date.setText(String.valueOf("n/a"));
			tv_data_titles.setText(String.valueOf("n/a"));
			tv_data_values.setText(String.valueOf("n/a"));
		}else{
			tv_title.setText(getString_Title(item));
			tv_start_date.setText(getDayString(item.Start_Date));
			tv_end_date.setText(getDayString(item.End_Date));
			tv_data_titles.setText(getString_Titles(item));
			tv_data_values.setText(getString_Values(item));
		}
	}
	
	private String getDayString(String value){
		if(value != null && value.length() > 0){
			return value.substring(0, 15);
		}
		return "";
	}
	
	public void setItem(HistoryItem item){
		TextView tv_title = (TextView)findViewById(R.id.tv_title);
		TextView tv_start_date =  (TextView)findViewById(R.id.tv_start_date);
		TextView tv_end_date =  (TextView)findViewById(R.id.tv_end_date);
		TextView tv_data_titles = (TextView)findViewById(R.id.tv_data_titles);
		TextView tv_data_values = (TextView)findViewById(R.id.tv_data_values);
		if(item == null){
			tv_title.setText(String.valueOf("n/a"));
			tv_start_date.setText(String.valueOf("n/a"));
			tv_end_date.setText(String.valueOf("n/a"));
			tv_data_titles.setText(String.valueOf("n/a"));
			tv_data_values.setText(String.valueOf("n/a"));
		}else{
			tv_title.setText(getString_Title(item));
			tv_start_date.setText(getDayString(item.Start_Date));
			tv_end_date.setText(getDayString(item.End_Date));
			tv_data_titles.setText(getString_Titles(item));
			tv_data_values.setText(getString_Values(item));
		}
	}
	
	private String getString_Title(HistoryItem item) {
		String out = "n/a";
		if(item != null) {
			out = String.format("No.%s %s",item.mNo, getResourceString(R.string.history_detail_cellected_data),Locale.getDefault());
		}
		return out;
	}
	
	private String getResourceString(int id){
		if(id == 0) return "";
		try{
			return mContext.getResources().getString(id);
		}
		catch(Exception e){
			
		}
		return "";
	}
	
	private String getString_Titles(HistoryItem item) {
		String out = "n/a";
		String enter = "\r\n";
		if(item != null) {
			out = getResourceString(R.string.history_detail_net)+":"+enter;
			out += getResourceString(R.string.history_detail_cell_id)+":"+enter;
			out += getResourceString(R.string.history_detail_rssi)+":"+enter;
			out += getResourceString(R.string.history_detail_latency)+":"+enter;
			out += getResourceString(R.string.history_detail_packet_loss)+":"+enter;
			out += getResourceString(R.string.history_detail_download)+":"+enter;
			out += getResourceString(R.string.history_detail_upload)+":"+enter;
			out += getResourceString(R.string.history_detail_gps_latitude)+":"+enter;
			out += getResourceString(R.string.history_detail_gps_longitude)+":"+enter;
			out += getResourceString(R.string.history_detail_gps_accuracy)+":"+enter;
		}
		return out;
	}
	private String getString_Values(HistoryItem item) {
		String out = "n/a";
		String enter = "\r\n";
		if(item != null) {
			out = item.mNet+enter;
			out += getCellID(item.Cell_ID)+enter;
			out += getRssiValue(item.RSSI)+enter;
			out += getLatency(item.Latency)+" ms"+enter;
			out += getLoss(item.PacketLoss)+" %"+enter;
			out += getThroughput(item.Avg_DL_Throughput)+" Mbps"+enter;
			out += getThroughput(item.Avg_UL_Throughput)+" Mbps"+enter;
			out += getGpsValue(item.Gps_latitude)+enter;
			out += getGpsValue(item.Gps_Longitude)+enter;
			out += getAccuracyValue(item.Gps_Accuracy)+enter;
		
		}
		return out;
	}
	
	private String getCellID(String value) {
		String out = null;
		if(value.equals("-1")){
			out = "N/A";
		}
		else {
			out = value;
		}
		return out;
	}
	
	private String getRssiValue(String value) {
		if(value == null || value.length() == 0){
			return "N/A";
		}
		
		double val = Double.parseDouble(value);
		String out = null;
		if(value.equals("-1")){
			out = "N/A";
		}
		else if(value.equals("2.1474837E8")) {
			out = "N/A";
		}
		else if(val == Double.MAX_VALUE || val == Double.MIN_VALUE || val == Double.NaN){
			out = "N/A";
		}else {
			out = String.format(Locale.getDefault(), "%.2f", val);
			out = out + " dBm";
		}
		return out;
	}
	
	private String getAccuracyValue(String value) {
		if(value == null || value.length() == 0){
			return "N/A";
		}
		
		double val = Double.parseDouble(value);
		String out = null;
		if(value.equals("-1")){
			out = "N/A";
		}
		else if(value.equals("2.1474837E8")) {
			out = "N/A";
		}
		else if(val == Double.MAX_VALUE || val == Double.MIN_VALUE || val == Double.NaN){
			out = "N/A";
		}else {
			out = String.format(Locale.getDefault(), "%.2f", val);
			out = out + " m";
		}
		return out;
	}
	
	private String getGpsValue(String value) {
		if(value == null || value.length() == 0){
			return "0";
		}
		
		double val = Double.parseDouble(value);
		String out = null;
		if(val == Double.MAX_VALUE || val == Double.MIN_VALUE || val == Double.NaN){
			out = "N/A";
		}else {
			out = String.format(Locale.getDefault(), "%.6f", val);
		}
		return out;
	}
	
	
	private String getLoss(String value){
		if(value == null || value.length() == 0){
			return "0";
		}
		
		if(value.equalsIgnoreCase("null")){
			return "0";
		}
		double value_double = Double.parseDouble(value);
		value = String.format(Locale.getDefault(), "%.2f", value_double);
		return value;
	}
	
	private String getLatency(String value){
		if(value == null || value.length() == 0){
			return "0";
		}
		
		if(value.equalsIgnoreCase("null")){
			return "0";
		}
		double value_double = Double.parseDouble(value);
		value_double /= 1000;
		value = String.format(Locale.getDefault(), "%.2f", value_double);
		return value;
	}
	private String getThroughput(String value){
		if(value == null || value.length() == 0){
			return "0";
		}
		
		if(value.equalsIgnoreCase("null")){
			return "0";
		}
		double value_double = Double.parseDouble(value);
		value_double /= 1000000;
		value = String.format(Locale.getDefault(), "%.2f", value_double);
		return value;
	}
	
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		int id = v.getId();
		switch(id){
		case R.id.btn_Close:
			dismiss();
			break;
		default:
			break;
		
		}
	}

}
