package com.samknows.measurement.schedule;

import java.io.Serializable;
import org.json.JSONException;
import org.json.JSONObject;
import android.util.Log;

import com.samknows.measurement.util.IdGenerator;


public class ServerInfo implements Serializable{
	
	private static final String TAG = ServerInfo.class.getSimpleName();

	public long id = IdGenerator.generate();


	public String latitude;
	public String longitude;
	public String latencyPort;
	public String speedTestPort;
	public String name;
	public String address;
	public String latencyAddress;
	
	
	public static ServerInfo parseJSON(JSONObject object) {
		ServerInfo info = new ServerInfo();
		//mandatory
		try {
			info.latitude = object.getString("latitude");
			info.longitude = object.getString("longitude");
			info.speedTestPort = object.getString("Speedtestport");
			info.latencyPort = object.getString("latencyport");
			info.name = object.getString("Name");
			info.address = object.getString("Address");
		}
		catch(JSONException e){
			Log.e(TAG,"JSONException:"+e.getMessage());
		}
		//optional
		try {
			info.latencyAddress = object.getString("latencyaddress");
		} catch (JSONException e) {
			info.latencyAddress = info.address;
		}		
		
		return info;
	}
	

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (int) (id ^ (id >>> 32));
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ServerInfo other = (ServerInfo) obj;
		if (id != other.id)
			return false;
		return true;
	}
	
}
