package com.samknows.measurement.schedule.datacollection;

import java.io.Serializable;
import java.util.List;

import org.json.JSONObject;
import com.samknows.measurement.test.TestContext;

public abstract class BaseDataCollector implements Serializable{
	private static final long serialVersionUID = 1L;
	public boolean isEnabled;
	protected TestContext tc;
	
	public void start(TestContext ctx){
		clearData();
		tc = ctx;
	}
	public void stop(TestContext ctx){}
	public abstract List<String> getOutput();
	public abstract List<JSONObject> getJSONOutput();
	public abstract List<JSONObject> getPassiveMetric();
	public abstract void clearData();
	public enum Type {
		Location, Environment
	}
	
}
